/********************************************************
routine pour dessiner un sprite de 3 colonnes (24 pixels)
********************************************************/
void spr24(short x,short y,short h,unsigned char* sprite,unsigned char* mask,void* dest) {
    register unsigned char  *addr  = ((unsigned char*)dest)+((y<<5)-(y<<1)+(x>>3));
    register unsigned short  shift1 = x & 7;
    register unsigned short  shift2;
    register unsigned short  lineoffset = 27;
    register unsigned short  i;
    register unsigned char   startmask;
    register unsigned char   endmask;

    if (shift1) {
        shift2 = 8 - shift1;
        startmask = 0xff << shift2;
        endmask   = 0xff >> shift1;
        for (;h;h--,addr+=lineoffset) {
            *addr   &= ((*mask) >> shift1) | startmask;
            *addr++ |= *sprite >> shift1;
            for (i=1;i<3;i++) {
               unsigned char val = (*mask++) << shift2;
               *addr   &= val | ((*mask) >> shift1);
               *addr   |= ((*sprite++) << shift2);
               *addr++ |= (*sprite >> shift1);
            }
            *addr &= ((*mask++) << shift2) | endmask;
            *addr |= (*sprite++ << shift2);
        }
    }
    else {
        for (;h;h--,addr+=lineoffset) {
            for (i=0;i<3;i++) {
                *addr   &= *mask++;
                *addr++ |= *sprite++;
            }
        }
    }
}

unsigned char *pl1;
unsigned char *pl0;


/*************************************/
// routines d' ACCES AUX PIXELS
/*************************************/
#define PIXOFFSET(x,y)  ((y<<5)-(y<<1)+(x>>3))
#define PIXADDR(p,x,y)  (((unsigned char*)(p))+PIXOFFSET(x,y))
#define PIXMASK(x)      ((unsigned char)(0x80 >> ((x)&7)))
#define SETPIX(a,m)   (*(a) |= (m))
#define CLRPIX(a,m)   (*(a) &= ~(m))
#define XORPIX(a,m)   (*(a) ^= (m))
#define PIXUP(a)      ((a)-=30)
#define PIXDOWN(a)    ((a)+=30)
#define PIXLEFT(a,m)   asm("rol.b  #1,%0;bcc.s  0f;subq.l #1,%1;0:": "=d" (m), "=g" (a) : "0" (m), "1" (a))
#define PIXRIGHT(a,m)  asm("ror.b  #1,%0;bcc.s  0f;addq.l #1,%1;0:": "=d" (m), "=g" (a) : "0" (m), "1" (a))
#define ABS(a)          (((a)<0) ? -(a): (a))
#define SIGN(a)  (((a)<0) ? 0 : 1)

/*************************************/
//draws a line fastly that standard DrawLine
/*************************************/
inline void drawline(unsigned char* plane,short x1,short y1,short x2,short y2,short mode)
{
    short d,x,y,ax,ay,sx,sy,dx,dy;
    unsigned char *pixaddr;
    unsigned char pixmask;

    dx = x2 - x1;
    ax = ABS(dx)<<1;
    sx = SIGN(dx);
    dy = y2 - y1;
    ay = ABS(dy)<<1;
    sy = SIGN(dy);
    x = x1;
    y = y1;
    
    pixaddr=PIXADDR(plane, x, y);
    pixmask=PIXMASK(x);

    if (mode == A_REPLACE) {
        if (ax>ay) {           // x
            d = ay - (ax>>1);
            do {
                SETPIX(pixaddr,pixmask);
                if (x==x2) return;
                if (d>=0) {
                    if(sy) PIXDOWN(pixaddr);
                    else   PIXUP(pixaddr);
                    d -= ax;
                }
                if (sx) {
                    PIXRIGHT(pixaddr, pixmask);
                    x++;
                }
                else {
                    PIXLEFT(pixaddr, pixmask);
                    x--;
                }
                d += ay;
            } while(1);
        }
        else {                 // y
            d = ax - (ay>>1);
            do {
                SETPIX(pixaddr,pixmask);
                if (y==y2) return;
                if (d>=0) {
                    if (sx) PIXRIGHT(pixaddr, pixmask);
                    else    PIXLEFT(pixaddr, pixmask);
                	d -= ay;
                }
                if (sy) {
                    PIXDOWN(pixaddr);
                    y++;
                }
                else {
                    PIXUP(pixaddr);
                    y--;
                }
                d += ax;
            } while(1);
        }
    }

    else if (mode == A_REVERSE) {
        if (ax>ay) {           // x
            d = ay - (ax>>1);
            do {
                CLRPIX(pixaddr,pixmask);
                if (x==x2) return;
                if (d>=0) {
                    if (sy) PIXDOWN(pixaddr);
                    else    PIXUP(pixaddr);
                    d -= ax;
                }
                if (sx) {PIXRIGHT(pixaddr, pixmask);x++;}
                else    {PIXLEFT(pixaddr, pixmask);x--;}
                d += ay;
            } while(1);
        }
        else {                 // y
            d = ax - (ay>>1);
            do {
                CLRPIX(pixaddr,pixmask);
                if (y==y2) return;
                if (d>=0) {
                    if (sx) PIXRIGHT(pixaddr, pixmask);
                    else    PIXLEFT(pixaddr, pixmask);
                	d -= ay;
                }
                if(sy) {PIXDOWN(pixaddr);y++;}
                else   {PIXUP(pixaddr);y--;}
                d += ax;
            } while(1);
        }
    }


    else if (mode == A_XOR) {
        if (ax>ay) {           // x
            d = ay - (ax>>1);
            do {
                XORPIX(pixaddr,pixmask);
                if (x==x2) return;
                if (d>=0) {
                    if (sy) PIXDOWN(pixaddr);
                    else    PIXUP(pixaddr);
                    d -= ax;
                }
                if (sx) {PIXRIGHT(pixaddr, pixmask);x++;}
                else    {PIXLEFT(pixaddr, pixmask);x--;}
                d += ay;
            } while(1);
        }
        else {                 // y
            d = ax - (ay>>1);
            do {
                XORPIX(pixaddr,pixmask);
                if (y==y2) return;
                if (d>=0) {
                    if (sx) PIXRIGHT(pixaddr, pixmask);
                    else    PIXLEFT(pixaddr, pixmask);
                	d -= ay;
                }
                if (sy) {PIXDOWN(pixaddr);y++;}
                else    {PIXUP(pixaddr);y--;}
                d += ax;
            } while(1);
        }
    }
}

/*************************************/
//MACROS FOR EASY WAY TO DRAW PIX FAST
/*************************************/
#define GETPIX(p,x,y)   (!(!(*PIXADDR(p,x,y) & PIXMASK(x))))
#define PIX(p,x,y)   (*PIXADDR(p,x,y) |=  PIXMASK(x))
#define CLPIX(p,x,y)   (*PIXADDR(p,x,y) &= ~PIXMASK(x))
#define XOR(p,x,y)   (*PIXADDR(p,x,y) ^=  PIXMASK(x))

/*************************************/
//draws a non-filled rect on defined plane
/*************************************/
void rectangle(short x,short y,short x2,short y2,short attr,unsigned char *plane)
{
	drawline (plane,(x+1),y,(x2-1),y,attr);
	drawline (plane,(x+1),y2,(x2-1),y2,attr);
	drawline (plane,x,y,x,y2,attr);
	drawline (plane,x2,y,x2,y2,attr);
}

void blackdrawline(short x,short y,short x2,short y2,short attr)
{
	drawline (pl1,x,y,x2,y2,attr);
	drawline (pl0,x,y,x2,y2,attr);
}

void blackDrawStr(short x,short y,char *msg,short attr)
{
SetPlane(0);
DrawStr(x,y,msg,attr);
SetPlane(1);
DrawStr(x,y,msg,attr);
}

void DrawClear(short k,short x,short ln)
{
	short i,j;
	for(i=0;i<k;i++)
		for(j=0;j<ln;j++)
			CLPIX(pl0,(x+j),(85+i));
}
